/*
 * nv_get.c
 *       novasub rouitines
 *              version 0.33  28-AUG-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.01  24-SEP-1992 Masaharu NOMACHI   (KEK)
 */

#include "novalib.h"
#include "nova.h"

/*
 * nova_get()
 *
 */
int nova_get(nd, address, length)
     struct NOVAD *nd; char **address; int *length;
{
  int rval,offset,size,pid;

  /*
   * if "request" is zero. request buffer
   */
  if (nd->request == 0) {
    nd->buffer->mtype = nd->snd_type;
    sprintf(nd->buffer->mtext,"request:%d:%d:",nd->pid,nd->novaid);
#ifdef VXWORKS
    rval = msgQSend(nd->snd_msgid, nd->buffer->mtext, NV_MSGLEN,
           WAIT_FOREVER, MSG_PRI_NORMAL);
#else
    rval = msgsnd(nd->snd_msgid, nd->buffer, NV_MSGLEN, 0);
#endif
    if (rval < 0) {
      perror("nv_get: send message");
      return -1;
    }
  }

  /*
   * get message from the buffer manager
   */
#ifdef VXWORKS
  /* Not really wait forever, just a second.  It is impossible to stop
   * the waiting.
   */
  rval = msgQReceive(nd->rcv_msgid, nd->buffer->mtext, NV_MSGLEN,
         sysClkRateGet());
  if (rval < 0) return 1;
#else
  rval = msgrcv(nd->rcv_msgid,nd->buffer, NV_MSGLEN,nd->rcv_type,0);
  if (rval < 0) {
    if (errno == EINTR) return 1;
    perror("nv_get: receive message");
    return -1;
  }
#endif
  rval = sscanf(nd->buffer->mtext,"ready:%d:%d:%d",&pid,&offset,&size);
  if (rval != 3) {
    rval = sscanf(nd->buffer->mtext,"error:%d:0:0:",&pid);
    printf("nv_get: error message is returned %s\n",nd->buffer->mtext);
    return -1;
  }
  if ( pid != (nd->pid)) {
    printf("nv_get: wrong pid is returned %d/%d\n",pid,nd->pid);
    return -1;
  }
  if (offset == 0 && size == 0) {
      *address = 0;
      *length = 0;
      return 1;
  }
  else {
      *address = (char *)((int)nd->base + offset);
      *length  = size;
      return 0;
  }
}


