/*
 * nv_get_with_sig.c
 *       novasub rouitines
 *
 *              version 2.00  24-FEB-1994 Masaharu NOMACHI   (KEK)
 */

#include "novalib.h"
#include "nova.h"

/*
 * nova_get_with_sig()
 *
 */
int nova_get_with_sig(nd, address, length, significance)
     struct NOVAD *nd; char **address; int *length, *significance;
{
  int rval,offset,size,pid;

  /*
   * if "request" is zero. request buffer
   */
  if (nd->request == 0) {
    nd->buffer->mtype = nd->snd_type;
    sprintf(nd->buffer->mtext,"request:%d:%d:",nd->pid,nd->novaid);
#ifdef VXWORKS
    rval = msgQSend(nd->snd_msgid, nd->buffer->mtext, NV_MSGLEN,
           WAIT_FOREVER, MSG_PRI_NORMAL);
#else
    rval = msgsnd(nd->snd_msgid, nd->buffer, NV_MSGLEN, 0);
#endif
    if (rval < 0) {
      perror("nv_get: send message");
      return -1;
    }
  }

  /*
   * get message from the buffer manager
   */
#ifdef VXWORKS
  /* Not really wait forever, just a second.  It is impossible to stop
   * the waiting.
   */
  rval = msgQReceive(nd->rcv_msgid, nd->buffer->mtext, NV_MSGLEN,
         sysClkRateGet());
  if (rval < 0) return 1;
#else
  rval = msgrcv(nd->rcv_msgid,nd->buffer, NV_MSGLEN,nd->rcv_type,0);
  if (rval < 0) {
    if (errno == EINTR) return 1;
    perror("nv_get: receive message");
    return -1;
  }
#endif
  rval = sscanf(nd->buffer->mtext,"ready:%d:%d:%d:%d",
		&pid,&offset,&size,significance);
  if (rval != 4) {
    rval = sscanf(nd->buffer->mtext,"error:%d:0:0:",&pid);
    printf("nv_get: error message is returned %s\n",nd->buffer->mtext);
    return -1;
  }
  if ( pid != (nd->pid)) {
    printf("nv_get: wrong pid is returned %d/%d\n",pid,nd->pid);
    return -1;
  }
  if (offset == 0 && size == 0) {
      *address = 0;
      *length = 0;
      return 1;
  }
  else {
      *address = (char *)((int)nd->base + offset);
      *length  = size;
      return 0;
  }
}


