/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      July 20, 1992                                            */
/*        This is file generic.h                                 */
/*                                                               */
/*---------------------------------------------------------------*/


/*---------------------------------------------------------------*/
/*            Return Codes for Different Operations              */
/*---------------------------------------------------------------*/
#define  INTEGER            1       /* int for var_dict      */
#define  STRING             2       /* (char *) for var_dict */
#define  REAL               3       /* float for var_dict    */
#define  CMD_NAME           10      /* Command Name Length   */
#define  VAR_NAME           20      /* Variable Name Length  */
#define  PROCESS_NAME       20      /* Process Name Length   */

struct cmd_dict_type {              /* struct for cmd_dict   */
   char name[CMD_NAME];
   int  (*proc_addr)();
};

struct var_dict_type {              /* struct for var_dict   */
   char name[VAR_NAME];
   int  type;
   int  addr;
};

#define END_STATE    0
#define BEGIN_STATE  1
#define PAUSE_STATE  2
#define RESUME_STATE 3

extern int debug_level;
extern int status;
extern char process_name[];

/*---------------------------------------------------------------*/
/*                                                               */
/*      This holds the name of the NOVA event source machine.    */
/*                                                               */
/*---------------------------------------------------------------*/
extern char Nova_Host[];
extern int nova_prio;
extern char ownpname[];

