#ifndef SDC_PACK_MSG_C_HEADER
#define SDC_PACK_MSG_C_HEADER
/******************************************************************
**
**                    MURMUR Message Utility
**
** File: sdc_pack_msg_c.h
** Created: Wed Nov 11 11:35:11 1992
** Message Input File: sdc_pack.msg
** By User: ball
**
******************************************************************/
/*   This is the primary message file for the murmur error messages */
/*   of sdc_pack.  The facility number is arbitrarily chosen as 100 decimal. */
/*   The database files are generated on pablo via the commands: */
/*      cd $SDC_PACK/murmur_client/error/inc */
/*      message sdc_pack.msg $SDC_PACK/murmur_client/error/lib */
/*      $SDC_PACK/bin/murmur_con <sdc_pack.lis */
#define sdc_pack_facnum 0X64
/* ######################################################################## */
/*   General errors.  This section is constructed differently than the */
/*   remaining sections below. */
/* 		First the general Success message. */
#define	   General_Success    0X80190009
/* 		Next, Informational message. */
#define	   General_Info    0X80190013
/* 		Next, Warning message. */
#define	   General_Warning    0X8019001A
/* 		Finally, the generalized Error message. */
#define	   General_Error    0X80190024
/* ######################################################################## */
/*   Run Control section */
/* 		First the Successes. */
#define	   Runco_Execute    0X80190051
/* 		Next, Informational. */
#define	   Runco_Start    0X801900A3
#define	   Runco_End    0X801900AB
#define	   Runco_Suspend    0X801900B3
#define	   Runco_Resume    0X801900BB
/* 		Next, Warnings. */
#define	   Runco_Incompat    0X801900F2
#define	   Runco_NotDone    0X801900FA
/* 		Finally, the Errors. */
#define	   Runco_No_Xecute    0X80190144
#define	   Runco_ANY_comm    0X8019014C
/* ######################################################################## */
/*   XPC section */
/* 		First the Successes. */
#define	   XPC_STRT    0X80190371
#define	   XPC_STOP    0X80190379
/* 		Next, Informational. */
#define	   XPC_REstrt    0X801903C3
#define	   XPC_Self_strt    0X801903CB
#define	   XPC_Self_stop    0X801903D3
/* 		Next, Warnings. */
#define	   XPC_NOstrt    0X80190412
/* 		Finally, the Errors. */
#define	   XPC_Dead    0X80190464
#define	   XPC_Send    0X8019046C
/* ######################################################################## */
/*   XPC Checker section */
/* 		First the Successes. */
/* 		Next, Informational. */
#define	   XPC_Chk_XPC_rstrt    0X801906E3
/* 		Next, Warnings. */
/* 		Finally, the Errors. */
#define	   XPC_Chk_XPC_dead    0X80190784
/* ######################################################################## */
/*   Operator section */
/* 		First the Successes. */
#define	   Oper_Send_OK    0X801909B1
/* 		Next, Informational. */
/* 		Next, Warnings. */
#define	   Oper_NotCompat    0X80190A52
#define	   Oper_NO_Send    0X80190A5A
/* 		Finally, the Errors. */
#endif
