#ifndef SDC_PACK_MSG_CXX_HEADER
#define SDC_PACK_MSG_CXX_HEADER
//*****************************************************************
//**
//**                  MURMUR Message Utility
//**
//** File: sdc_pack_msg_cxx.h
//** Created: Wed Nov 11 11:35:11 1992
//** Message Input File: sdc_pack.msg
//** By User: ball
//**
//******************************************************************
//   This is the primary message file for the murmur error messages
//   of sdc_pack.  The facility number is arbitrarily chosen as 100 decimal.
//   The database files are generated on pablo via the commands:
//      cd $SDC_PACK/murmur_client/error/inc
//      message sdc_pack.msg $SDC_PACK/murmur_client/error/lib
//      $SDC_PACK/bin/murmur_con <sdc_pack.lis
const unsigned long sdc_pack_facnum = 0X64;
// ########################################################################
//   General errors.  This section is constructed differently than the
//   remaining sections below.
// 		First the general Success message.
const	unsigned long    General_Success = 0X80190009;
// 		Next, Informational message.
const	unsigned long    General_Info = 0X80190013;
// 		Next, Warning message.
const	unsigned long    General_Warning = 0X8019001A;
// 		Finally, the generalized Error message.
const	unsigned long    General_Error = 0X80190024;
// ########################################################################
//   Run Control section
// 		First the Successes.
const	unsigned long    Runco_Execute = 0X80190051;
// 		Next, Informational.
const	unsigned long    Runco_Start = 0X801900A3;
const	unsigned long    Runco_End = 0X801900AB;
const	unsigned long    Runco_Suspend = 0X801900B3;
const	unsigned long    Runco_Resume = 0X801900BB;
// 		Next, Warnings.
const	unsigned long    Runco_Incompat = 0X801900F2;
const	unsigned long    Runco_NotDone = 0X801900FA;
// 		Finally, the Errors.
const	unsigned long    Runco_No_Xecute = 0X80190144;
const	unsigned long    Runco_ANY_comm = 0X8019014C;
// ########################################################################
//   XPC section
// 		First the Successes.
const	unsigned long    XPC_STRT = 0X80190371;
const	unsigned long    XPC_STOP = 0X80190379;
// 		Next, Informational.
const	unsigned long    XPC_REstrt = 0X801903C3;
const	unsigned long    XPC_Self_strt = 0X801903CB;
const	unsigned long    XPC_Self_stop = 0X801903D3;
// 		Next, Warnings.
const	unsigned long    XPC_NOstrt = 0X80190412;
// 		Finally, the Errors.
const	unsigned long    XPC_Dead = 0X80190464;
const	unsigned long    XPC_Send = 0X8019046C;
// ########################################################################
//   XPC Checker section
// 		First the Successes.
// 		Next, Informational.
const	unsigned long    XPC_Chk_XPC_rstrt = 0X801906E3;
// 		Next, Warnings.
// 		Finally, the Errors.
const	unsigned long    XPC_Chk_XPC_dead = 0X80190784;
// ########################################################################
//   Operator section
// 		First the Successes.
const	unsigned long    Oper_Send_OK = 0X801909B1;
// 		Next, Informational.
// 		Next, Warnings.
const	unsigned long    Oper_NotCompat = 0X80190A52;
const	unsigned long    Oper_NO_Send = 0X80190A5A;
// 		Finally, the Errors.
#endif
