/*************************************************
 * CVS Log
 * message.c,v
 * Revision 1.1.1.1  1993/07/14  19:43:21  dbrenner
 * UNIDAQ 2.1 distribution - July 14,1993
 *
*************************************************/
/*************************************************************************

	messagegen is the murmur facility message generation utility.
It takes as input a message filename and creates c,c++and fortran header
files and creates the needed databases for error reporting, etc.

*************************************************************************/

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <ctype.h>
#include <strings.h>
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#ifndef MUR_NODB
#include <osfcn.h>
#endif
#ifdef MUR_IRIX
#include <getopt.h>
#endif
#include "message.h"
#include "y.tab.h"

/* For getopt. */
extern char *optarg;

extern int optind, opterr;
extern int sys_nerr;
extern char *sys_errlist[];

char hexstring[256], keystring[256], txtstring[256], idstring[256];
char octstring[256], decstring[256];
char sevstring[2], defsevstring[2],groupstring[256];
char commentstring[256], helpfile[256],defhelpfile[256],msghelpfile[256];
char color[14], defcolor[14], msgcolor[14];
char inputline[1024];
char EOL = FALSE;
char dumpobj =FALSE;

char error_text[500];
char facility_name[17];
char prefix_name[17];
int  facility_number = 0;
int  severity_number;
int  message_number;
int  defseverity_number;
int  message_code;
char message_mnemonic[17];
int  base = 1;
char defgroups_defined = FALSE;
char defhelp_defined = FALSE;
char msggroups_defined = FALSE;
char msghelp_defined = FALSE;
char noprefix = FALSE;
char trailingcomment = FALSE;
char listing  = TRUE;
char  error_flag  = FALSE;
int  error_count = 0;

/* 
** define list header elements and current elements
*/
struct element *keywords, *currentkeyword, *firstkeyword;
struct element *groups, *currentgroup, *firstgroup;

FILE *cdesc, *Fdesc, *cxxdesc, *listdesc;	/* file descriptors */
int  hdesc, ftokdesc;
unsigned long status, gstatus, hstatus, hstatus2, fstatus, mstatus;
unsigned long  mgstatus,msgstatus, rstatus,Wrdstatus,stat5;
#ifndef MUR_NODB
mur_WrMessage wrmess(status);
mur_WrMessGroupList defgrouplist(gstatus);
mur_WrMessGroupList msggrouplist(msgstatus);
mur_WrGroupList murgrouplist(mgstatus);
mur_WrGroupList mnemoniclist(mstatus);
mur_WrGroupList helpfilelist(stat5);
mur_WrFacilityList faclist(fstatus);
mur_WrDefaultRoute defaultroute(rstatus);
mur_WrDisplay	displayconfig(Wrdstatus);
mur_WrMouseActMenu defhelplist(hstatus);
mur_WrMouseActMenu msghelplist(hstatus2);
#endif

#ifndef MUR_NODB
extern "C"
{
int yyparse();
int yywrap();
void upcpy(char *,char *);
void yyerror(char *);
void clrstr(char *);
void addtolist(struct element &, char *);
void resetlist(struct element *);
#ifdef MUR_SUNOS
int strcasecmp(char *, char *);
#endif
}
#else 
int yyparse();
#ifdef MUR_SUNOS
#ifdef MUR_NODB
int strcasecmp();
#else
int strcasecmp(char *, char *);
#endif
#endif
#endif

#ifdef MUR_NODB
void yyerror(s)
       char *s;
#else
void
yyerror(char *s)
#endif
	{
	extern int yylineno;
	extern char yytext[];
	extern char listing;
	extern char error_flag;
	extern char inputline[];
	extern  int error_count;
	extern  char error_text[];

	error_count++;
	fprintf(stderr,"***lineno: %d - %s\n",yylineno, inputline);
	fprintf(stderr,"%s\n",s);
	fprintf(stderr,"%s\n",yytext);
	sprintf(error_text,"%s, token: %s",s,yytext);
	error_flag = 1;
}

#ifdef MUR_NODB
void 	addtolist(list, listelement)
	struct element *list;
	char *listelement;
	{
	   list->next = (struct element *)malloc(sizeof (struct element));
	   list->next->name = (char *)malloc (strlen(listelement)+1);
	   sprintf(list->next->name,"%s",listelement);
	   list->next->next = NULL;
	}

#else
void 	addtolist(struct element &list, char *listelement)
	{
	   list.next = (struct element *)malloc(sizeof (struct element));
	   list.next->name = (char *)malloc (strlen(listelement)+1);
	   sprintf(list.next->name,"%s",listelement);
	   list.next->next = NULL;
	}
#endif

#ifdef MUR_NODB
void 	resetlist(list)
	struct element *list;
#else
void 	resetlist(struct element *list)
#endif
	{
	struct element *next_one;
	struct element *current_one;
	   
	   current_one = list->next;
	   while (current_one != NULL)
	   {
	     next_one = current_one->next;
	     free(current_one);
	     current_one = next_one;
	   }
	   list->next = NULL;
	}

#ifdef MUR_NODB
void 
	usage (s) 
	char *s;
	{
	   printf("Usage: %s [-sl] [-sdb] [msg_input_file] [product_db_dir]\n",
		   s);
	   exit (2);
	}

#else
void 
	usage (char *s) {
  	   cout << "Usage: " << s 
	        << " [-sl] [-sdb] [msg_input_file] [product_db_dir]"
		<< "\n" << flush ;
	   exit (2);
	}

#endif

#ifdef MUR_NODB
void 
	clrstr( s) 
	char *s;
	{
#else
void 
	clrstr( char *s) {
#endif
		while (*s != '\0'){
			*s++ = '\0';
			}
	}

#ifdef MUR_NODB
void
	upcpy(mine, old) 
	char *mine;
	char *old;
	{
#else
void 
	upcpy(char *mine, char *old) {
#endif
	register int c;
 	while (c = (int) *old++) {
		*mine++ = islower(c)?toupper(c):c;
		}
	*mine = 0;
	}

int 
	yywrap()
		{
		return 1;
		}

#ifdef MUR_NODB
int	mur_Translate(env)
	char *env;
#else
int	mur_Translate(char *env)
#endif
	{
	char *evalue;
	char workstring[256];
	int  length;

		clrstr(workstring);
/*
** get length of help file string from first character after '$' to slash
** i.e. the environment variable only 
*/
		length = strcspn(&env[1],"/");
		strncpy(workstring,&env[1],length);
		workstring[length]   = '\0';

		evalue =  getenv(workstring);
		if(evalue != NULL)
	        {
		   sprintf(workstring,"%s%s",evalue,&env[length+1]);
		   sprintf(env,"%s",workstring);
		}
		else
		   return(0);

	        return(1);
	}

#ifndef MUR_NODB

void	printGroups(FILE *listdesc, mur_DbInterface *dinter, mur_DbInterface *ginter)
	{
        const char *varstring;
	char  key[64];

           fprintf(listdesc,
                   "\nMessage Groups Listing : \n**********************\n\n");
	   for (status=dinter->first(wrmess); MUR_MSG_SUCCESS(status); 
	        status=dinter->next(wrmess))
           {
	      if (!wrmess.body->groupflag)  goto next_msg;
              
	      sprintf(key,"%sGroupList",dinter->key());
	      if (key[0] != '8')  goto next_msg; /* internal msg...ig it*/
	      if (dumpobj) cout  << "key=" <<  key << "\n"  << flush;

	      fprintf(listdesc,"%16s : ", wrmess.body->mnemonic);
	      gstatus=ginter->fetch(key,defgrouplist);
	      if (MUR_MSG_FAIL(gstatus))
	      {
	         cerr << "GUIEditDb fetch error - Group Information "
		      << "terminated.\n"  <<  flush;
	         fprintf(listdesc,"%s %s"," GUIEditDb  fetch error - ",
		         "Group  Information  terminated.");
		 return;
	      }
	      for (varstring=defgrouplist.first();  varstring;  
	   	   varstring=defgrouplist.next())
	      {
	          fprintf(listdesc,"  %s",varstring);
	      }
	      fprintf(listdesc,"\n");
next_msg: ;

           }
	return;
	}

void	printHelps(FILE *listdesc)
	{
	const char *helpstring;
	const  char *mnemonic;
	int  i;

           fprintf(listdesc,
	          "\nMessage Help Listing : \n********************\n\n");
	   
	   for (helpstring=helpfilelist.first(); helpstring; 
		helpstring=helpfilelist.next())
	   {
	      fprintf(listdesc,"%s (%d messages) : \n\n",helpstring,
		      helpfilelist.item2());
	      i = 0;
	      mnemonic = mnemoniclist.first();
	      while ((i<helpfilelist.item2()) && (mnemonic != NULL ))
	      {
	         if (mnemoniclist.item1() == helpfilelist.item1())
	         {
		   fprintf(listdesc,"%s",mnemonic);
	           i++;
		   if( i<helpfilelist.item2())fprintf(listdesc,", ");
		   if ((i==helpfilelist.item2()) || (i%4 == 0))
		      fprintf(listdesc,"\n");
	         }
		 mnemonic = mnemoniclist.next();		 
	      }
	      fprintf(listdesc,"\n");
	   }
	   return;
	}

int	addInternalMsgs(mur_DbInterface &dbInterface, mur_DbInterface &ginterface)
	{
        int i;

	   if (MUR_MSG_FAIL(status)) return(0);
	   if (MUR_MSG_FAIL(gstatus)) return(0);

	   wrmess.body->code =  0;
	   for (i=0; i<=7;  i++) wrmess.body->argtypes[i] = 0;

	   wrmess.body->Xclientactflag = 0;
	   wrmess.body->groupflag = 1;
	   sprintf(wrmess.body->hexcode,"%8.8X",0);
	   sprintf(wrmess.body->prefix,"%s","");
	   sprintf(wrmess.body->facility,"%s","");
	   sprintf(wrmess.body->severity,"%s","");
           sprintf(wrmess.body->color,"%s",MUR_COLOR_BLUE);

           sprintf(wrmess.body->mnemonic,"%s","TEXTONLY");
	   sprintf(wrmess.body->precomputed,"%s",wrmess.body->mnemonic);
	   sprintf(wrmess.body->text,"%s","");
	   status = dbInterface.write("TextOnly",wrmess);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "dbInterface write failed \n" << flush;
	      return(0);
	   }
	   defgrouplist.append("TEXTONLY",1);
	   status =  ginterface.write("TextOnlyGroupList",defgrouplist);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "ginterface write failed \n" << flush;
	      return(0);
	   }

           sprintf(wrmess.body->mnemonic,"%s","TIMESTAMP");
	   sprintf(wrmess.body->precomputed,"%s",wrmess.body->mnemonic);
	   sprintf(wrmess.body->text,"%s","");
	   status = dbInterface.write("Timestamp",wrmess);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "dbInterface write failed \n" << flush;
	      return(0);
	   }
	   defgrouplist.clear();
	   defgrouplist.append("TIMESTAMP",1);
	   status =  ginterface.write("TimestampGroupList",defgrouplist);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "ginterface write failed \n" << flush;
	      return(0);
	   }
	   
           sprintf(wrmess.body->mnemonic,"%s","UNKNOWN_MSG");
	   sprintf(wrmess.body->precomputed,"%s",wrmess.body->mnemonic);
	   sprintf(wrmess.body->text,"%s",
                   "Unknown message code, %X, received");
           wrmess.body->argtypes[0]  = MUR_U_LONG;
	   status = dbInterface.write("Unknown",wrmess);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "dbInterface write failed \n" << flush;
	      return(0);
	   }

	   defgrouplist.clear();
	   defgrouplist.append("UNKNOWN",1);
	   status =  ginterface.write("UnknownGroupList",defgrouplist);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "ginterface write failed \n" << flush;
	      return(0);
	   }

           sprintf(wrmess.body->mnemonic,"%s","DBERROR");
	   sprintf(wrmess.body->precomputed,"%s",wrmess.body->mnemonic);
	   sprintf(wrmess.body->color,"%s",MUR_COLOR_RED);
	   sprintf(wrmess.body->text,"%s  %s", 
		   "Error encountered translating message code, %X,",
	  	   "database error, %X. See Internal log file.");
           wrmess.body->argtypes[1] =  MUR_U_LONG;
	   status = dbInterface.write("DbError",wrmess);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "dbInterface write failed \n" << flush;
	      return(0);
	   }
	   defgrouplist.clear();
	   defgrouplist.append("DBERROR",1);
	   status =  ginterface.write("DbErrorGroupList",defgrouplist);
	   if (MUR_MSG_FAIL(status))
	   {
	      cerr  << "ginterface write failed \n" << flush;
	      return(0);
	   }

	   wrmess.body->groupflag = 0;
	   for(i=0; i<=7; i++)  wrmess.body->argtypes[i]=0;
	   return(1);
	}
 
void
	updateGroupList(mur_WrGroupList &murlist, mur_WrMessGroupList &grouplist)
	{
	const char *varstring;

/*
** Loop over message groups if group not found murmur groups add it
*/
	  for (varstring=grouplist.first();  varstring; 
	       varstring=grouplist.next())
	  {
/*
** if group name is not in the list, add it with zero refcount and 
** 1 to indicate it was set by the message generator
*/
	     if (MUR_MSG_FAIL(murlist.find(varstring)))
	        murlist.append(varstring,0,1);
	  }
	}
void
	updateGroupCount(mur_WrGroupList &murlist, mur_WrMessGroupList &grouplist)
	{
	const char *varstring;

	  for (varstring=grouplist.first();  varstring; 
	       varstring=grouplist.next())
	  {
	     if (MUR_MSG_SUCCESS(murlist.find(varstring)))
	     {
	        murlist.setitem1(murlist.item1() + 1);
	        murlist.body->item1++;
		if (dumpobj)
		{
	           cout << "groupname: " << varstring << " refcount: " 
		        << murlist.item1() << " total refcount: " 
		        << murlist.body->item1  << "\n" << flush;
		}
	     }
	     else 
	     {
		cerr << "Unrecognized group " << varstring << "\n"
		     <<  flush;
		error_count++;
	     }
	  }
	}
int
	casecheck(char newmessage[]) 
        {
	const  char *varstring;

	for (varstring = mnemoniclist.first(); varstring; 
	     varstring=mnemoniclist.next())
	{
	   if (strcasecmp(newmessage, (char *)varstring) == 0)
	      {
              cerr << "Message " << newmessage << " already exists\n"
		   << flush;
	      return(0);
	      }
	}
	return(1);/* all is well add message */
	}

#endif 	/* of ifndef MUR_NODB */

/* The test program blah blah blah 
   information.  See the help command (?) for a list of all commands. */

#ifdef MUR_NODB
main (argc, argv)
int argc;
char *argv[];
{
#else
main (int argc, char *argv[])  {
#endif
  int opt;
  time_t create_time;
  char	*timeout;
  char  *nameonly;
  char  *user;
#ifndef MUR_NODB
  char	databases = TRUE;
#else
  char  databases = FALSE;
#endif
  char  nofacility = TRUE;
  char  nocasecheck = FALSE;
  char  msg_defined = FALSE;
  char  groups_defined = FALSE;
  char  help_defined = FALSE;
  char  defhelp = FALSE;
  char	defgroup = FALSE;
  char  filename[256];
  char  UCfilename[256];	/* uppercase  version of filename */
  char  prd_db_dir[256];

  char listfile[256];		/* listing file */
  char cfile[256];		/* C Header file */
  char cxxfile[256]; 		/* C++ Header File */
  char Ffile[256];		/* FORTRAN header file */

  char ftokfile[256];		/* semaphore key file */  
  key_t ftok_key;

  char dbfile[256]; 	/* Message Database File name */
  char xclientdbfile[256];	/* Mouse Action Database */
  char guieditdbfile[256];	/* Messge Groups database */
  char messactdbfile[256];	/* Message Action Database */ 
  char *ext;

  int filelen;
  int dbcount  =0;	/* count of MessageDb  records written  */
  int Xcount =0;	/* count of Xclient records written  */
  int Gcount =0;	/* count of guie records written */
  int msg_count =0;	/* maintain a count of messages generated */
  int line_number = 0;	/* line number maintained for listing file */
  int helpfilenumber = 0; /* count of helpfiles active */
  int token;	/* parser token to determine msg utility action */
  int nbytes;
  int savedXflag, savedGflag;

  char helptext[8192];
  char newmessage[256];
  char key[64];
  unsigned long dstatus,Xstatus,Gstatus,Mstatus;

#ifndef MUR_NODB

  mur_DbInterface *dbInterface;
  mur_DbInterface *XInterface;
  mur_DbInterface *GInterface;
  mur_DbInterface *MInterface;

  /* Argument checking. */
  
  if (MUR_MSG_FAIL(status))
  {
     cout << "Failed constructing WrMessage\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(gstatus))
  {
     cout << "Failed constructing WrGroupList\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(hstatus))
  {
     cout << "Failed constructing WrMouseActMenu\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(fstatus))
  {
     cout << "Failed constructing WrFacilityList\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(rstatus))
  {
     cout << "Failed constructing RoDefaultRoute\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(Wrdstatus))
  {
     cout << "Failed constructing WrDisplay\n";
     exit(0);
  }
  if (MUR_MSG_FAIL(mstatus))
  {
     cout << "Failed constructing WrGroupList for mnemonics\n";
     cout << "No  case checking of message names will be done\n" <<  flush;
     nocasecheck = TRUE;
  }

#endif

/*
**  Input  is  always at  least  three parameters
*/
#ifndef MUR_NODB
  if (argc < 3)
  {
     cout << "Insufficient Parameters Specified\n";
     usage(argv[0]);
     exit(0);	
  }
#else
  if (argc < 2)
  {
     printf("Insufficient Parameters Specified\n");
     usage(argv[0]);
     exit(0);	
  }
#endif 

  while ((opt = getopt (argc, argv, "ds:")) != -1)
    switch (opt) {
    case 's' : if (strcmp(optarg,"l") == 0)
	          listing = FALSE;
	       else if (strcmp(optarg,"db") == 0)
		  databases = FALSE;
	       else
		  {
#ifdef MUR_NODB
		  printf("Invalid Option - %s%s\n",(char)opt,optarg);
#else
		  cout << " Invalid Option -" << (char) opt << optarg << "\n"
		       <<  flush;
#endif
		  usage(argv[0]);
		  }		
	       break;
    case 'd' : dumpobj = TRUE;
	       break;
   
#ifdef MUR_NODB
    default : printf("Invalid Option - %s\n",(char)opt);
	      usage(argv[0]);
	      break;
#else
    default : cout << "Invalid Option -" << (char)opt << "\n" << flush;
	      usage(argv[0]);
	      break;
#endif
    }

    if  ((databases && (argc <= (optind+1))) || (argv[optind] == NULL))
    {
#ifdef MUR_NODB
     printf("Missing Input file or Database Specification\n");
#else
     cout << "Missing Input file or Database Specification\n";
#endif
     usage(argv[0]);
     exit(0);	
    }

/* Initialization */

        /*handle message input file name */
    if( freopen(argv[optind], "r", stdin) == NULL )
    {
       perror(argv[optind]);
       exit(-1);
    }

    if (dumpobj)
    {
#ifndef MUR_NODB
	cout << "msg input file: "  << argv[optind] << "\n";
	if (databases) cout<< "product  Db dir: " << argv[optind+1] << "\n";
	cout << flush;
#else 
	printf("msg input file: %S\n",argv[optind]);
#endif
    }

/* generate file and database names */
/* calculate length without .msg extension */

	ext = strstr(argv[optind],".msg");
	if (ext != NULL) 
	   filelen = strlen(argv[optind]) - strlen(ext);
	else
	   filelen = strlen(argv[optind]);

	strncpy(filename,argv[optind],filelen); /* copied to filename) */
	filename[filelen] = 0; /* add null termination */

	sprintf(cfile,"%s%s",filename,"_msg_c.h");
	sprintf(Ffile,"%s%s",filename,"_msg_F.inc");
	sprintf(cxxfile,"%s%s",filename,"_msg_cxx.h");
	
	if (listing) 
	{
	   sprintf(listfile,"%s%s",filename,".lis");
	   listdesc = fopen(listfile, "w");
	   if (listdesc  == NULL)
	   {
	      perror(listfile);
	      exit(-1);
	   }
	}
	   
#ifndef MUR_NODB
	if (databases)
	{
	  strcpy(prd_db_dir,argv[optind+1]);
	  if (dumpobj) cout << "product Db Dir: "<< prd_db_dir << "\n" << flush;
	  sprintf(dbfile,"%s%s",prd_db_dir,"/MessageDb");
	  sprintf(xclientdbfile,"%s%s",prd_db_dir,"/XclientDb");
	  sprintf(guieditdbfile,"%s%s",prd_db_dir,"/GUIEditDb");
	  sprintf(messactdbfile,"%s%s",prd_db_dir,"/MessActDb");
	  sprintf(ftokfile,"%s%s",prd_db_dir,"/murmur_ftokDb");
	  if (dumpobj) 
	    cout << "dbfile: " << dbfile << "xclientdbfile: "
		 << xclientdbfile << "\n" << "guieditdbfile: "
		 << guieditdbfile << "\n" << "messactdbfile: "   
		 << messactdbfile << "\n" << flush;
	}

#endif

/* open all header files for writing */

	cdesc = fopen(cfile,"w");
	if (cdesc  == NULL)
	{
		perror(cfile);
		exit(-1);
	}

	cxxdesc = fopen(cxxfile,"w");
	if (cxxdesc  == NULL)
	{
		perror(cxxfile);
		exit(-1);
	}

	Fdesc = fopen(Ffile,"w");
	if (Fdesc  == NULL)
	{
		perror(Ffile);
  		exit(-1);
	}

/*
** Initialize list structures
*/
	keywords = (struct element *)malloc(sizeof(struct element));
	keywords->name = "";
	keywords->next = NULL;
	currentkeyword = keywords;
	firstkeyword = keywords;

	groups = (struct element *)malloc(sizeof(struct element));
	groups->name = "";
	groups->next = NULL;
	currentgroup = groups;
	firstgroup = groups;


/* write  creation headers */
	time(&create_time);
	timeout = ctime(&create_time);

	user =  getenv("USER");
	nameonly = strrchr(filename,'/');
	if (nameonly != NULL)  
	   upcpy(UCfilename,&nameonly[1]);
	else
	   upcpy(UCfilename,filename);

	fprintf(cdesc,"#ifndef %s_MSG_C_HEADER\n#define %s_MSG_C_HEADER\n",
		UCfilename,UCfilename);
	fprintf(cdesc,
        "/******************************************************************\n");
	fprintf(cdesc,"**\n** %41s\n","MURMUR Message Utility");
	fprintf(cdesc,"**\n** File: %s\n** Created: %s",cfile,timeout);
	fprintf(cdesc,"** Message Input File: %s.msg\n",filename);
	if (user != NULL) 
	   fprintf(cdesc,"** By User: %s\n**\n",user);
	else
	   fprintf(cdesc,"** By User: Unknown%s\n**\n");

	fprintf(cdesc,
       "******************************************************************/\n");

	fprintf(cxxdesc,"#ifndef %s_MSG_CXX_HEADER\n#define %s_MSG_CXX_HEADER\n",
		UCfilename,UCfilename);
	fprintf(cxxdesc,
        "//*****************************************************************\n");
	fprintf(cxxdesc,"//**\n//** %39s\n","MURMUR Message Utility");
	fprintf(cxxdesc,"//**\n//** File: %s\n//** Created: %s",cxxfile,timeout);
	fprintf(cxxdesc,"//** Message Input File: %s.msg\n",filename);

	if (user != NULL) 
	   fprintf(cxxdesc,"//** By User: %s\n//**\n",user);
	else
	   fprintf(cxxdesc,"//** By User: Unknown%s\n//**\n");

	fprintf(cxxdesc,
       "//******************************************************************\n");

	fprintf(Fdesc,
        "C ******************************************************************\n");
	fprintf(Fdesc,"C **\nC ** %39s\n","MURMUR Message Utility");
	fprintf(Fdesc,"C **\nC ** File: %s\nC ** Created: %s",Ffile,timeout);
	fprintf(Fdesc,"C ** Message Input File: %s.msg\n",filename);

	if (user != NULL) 
	   fprintf(Fdesc,"C ** By User: %s\nC **\n",user);
	else
	   fprintf(Fdesc,"C ** By User: Unknown%s\nC **\n");

	fprintf(Fdesc,
        "C ******************************************************************\n");


	if (listing)
	{
	fprintf(listdesc,
        "# ******************************************************************\n");
	fprintf(listdesc,"# **\n# ** %38s\n","MURMUR Message Utility Listing");
	fprintf(listdesc,"# **\n# ** File: %s\n# ** Created: %s",listfile,timeout);
	fprintf(listdesc,"# ** Message Input File: %s.msg\n",filename);

	if (user != NULL) 
	   fprintf(listdesc,"# ** By User: %s\n# **\n",user);
	else
	   fprintf(listdesc,"# ** By User: Unknown%s\n# **\n");

	fprintf(listdesc,
        "# ******************************************************************\n");
	}

#ifndef MUR_NODB

	if (databases)
	{
	ftok_key = ftok(prd_db_dir,0);
	if (ftok_key == -1)
	   {
	   cerr << "Error Creating ftok key  : " << sys_errlist[errno]
		<< "\n" << flush; 
	   exit(0);
	   }
	else
	   {
	   ftokdesc = open(ftokfile, O_EXCL | O_CREAT | O_RDWR, 0744);
	   if (errno != EEXIST)
              {	  
	      if (ftokdesc == -1)
	         {
	         cerr << "Error opening murmur_ftokDb file : "
		      << sys_errlist[errno] << "\n" << flush;
	         exit(0);
	         }
	      write(ftokdesc,(char *)&ftok_key,4);
              close(ftokdesc);
	      }

	   }
	dbInterface = new mur_DbInterface(dstatus, dbfile,
					 MUR_MESSAGEDB, MUR_NEWDB);
	XInterface = new mur_DbInterface(Xstatus, xclientdbfile, 
				   MUR_XCLIENTDB, MUR_NEWDB);
	GInterface = new mur_DbInterface(Gstatus, guieditdbfile,
				   MUR_GUIEDITDB, MUR_NEWDB);
	MInterface = new mur_DbInterface(Mstatus, messactdbfile,
				   MUR_MESSACTDB, MUR_NEWDB);
	if (MUR_MSG_FAIL(dstatus))
	{
	     perror("dbinterface failure");
	     exit(0);
	}
	if (MUR_MSG_FAIL(Xstatus))exit(0);
	if (MUR_MSG_FAIL(Gstatus))exit(0);
	if (MUR_MSG_FAIL(Mstatus))exit(0);

	}

/*
**	Add  internal messages first
*/
   if (databases)
   {
      if (!addInternalMsgs(*dbInterface, *GInterface)) exit(0);
      murgrouplist.clear();
      murgrouplist.append("DBERROR",1,1,1,0);
      murgrouplist.append("TEXTONLY",1,1,1,0);
      murgrouplist.append("TIMESTAMP",1,1,1,0);
      murgrouplist.append("UNKNOWN",1,1,1,0);
      murgrouplist.body->item1  = 4;
      status = GInterface->write("GroupList",murgrouplist);
      if (MUR_MSG_FAIL(status))  
      {
          cerr << "GInterface  write failure on  GroupList\n" << flush;
          exit(0);
      }
      else
         Gcount++;
      defgrouplist.clear();  /* start clean for message specific groups lists*/
   }

#endif

/*
**	Begin parsing and file generation loop 
*/

   clrstr(keystring);
   message_number = base;
   while (strcmp(keystring,"-END") != 0)
   {

next_token:

      clrstr(inputline);
      token = yyparse();
      if (token == KeyedID)
      {
         for (currentkeyword = firstkeyword->next; currentkeyword; 
	      currentkeyword = currentkeyword->next)
	 {
	    if (strncmp(currentkeyword->name,"-SEVERITY",strlen(currentkeyword->name)) == 0)
	    {
	    /*
	    ** parser has already filled in the severity, color etc. 
	    ** so reset them to the originals
	    */
	        sprintf(color,"%s",defcolor);
		sprintf(sevstring,"%s",defsevstring);
		severity_number = defseverity_number;
	    }
	    else if (strncmp(currentkeyword->name,"-GROUPS",strlen(currentkeyword->name)) == 0)
	    {
#ifndef MUR_NODB
	       msggrouplist.clear();
	       for(currentgroup = firstgroup->next; currentgroup;
	 	   currentgroup = currentgroup->next)
	       	   msggrouplist.append(currentgroup->name,1);
#endif
		resetlist(firstgroup);
		currentgroup = firstgroup;

	       groups_defined = TRUE;
	       msggroups_defined = TRUE;
#ifndef MUR_NODB
	       savedGflag = wrmess.body->groupflag;
	       wrmess.body->groupflag = 1;
  	       if (databases)
	       {
	          status = GInterface->fetch("GroupList",murgrouplist);
	          if (MUR_MSG_FAIL(status))
	          {
	             cout << "GInterface write failure"<< status 
	   	          << "\n" << flush;
                     exit(0);
	          }

	          updateGroupList(murgrouplist,msggrouplist);
	          if (dumpobj) cout << murgrouplist << "\n" << flush;

	          status = GInterface->write("GroupList",murgrouplist);
	          if (MUR_MSG_FAIL(status))
	          {
	             cout << "GInterface write failure"<< status 
		          << "\n" << flush;
                     exit(0);
	          }
	       }
#endif
	    }
	    else if (strncmp(currentkeyword->name,"-NOGROUPS",
			     strlen(currentkeyword->name)) == 0)
	    {
#ifndef MUR_NODB
		savedGflag = wrmess.body->groupflag;
	        msggroups_defined = FALSE;
	        wrmess.body->groupflag = 0;
		msggrouplist.clear();
#endif
	    }
	    else if (strncmp(currentkeyword->name,"-HELP",strlen(currentkeyword->name)) == 0)
	    {
	       if (helpfile[0] == '$') status = mur_Translate(helpfile);
	       if (!status)
	       {
#ifdef MUR_NODB
	          printf("Can't translate environmental variable: %s\n",
			  helpfile);
		  printf("Execution contining...\n");
#else
	          cerr << "Can't Translate environmental variable: "<< helpfile 
		       <<"\n" << flush;
		  if (databases)
		     {
		     cerr << "Terminating Program\n" << flush;
	    	     exit(0);
		     }
		  else
		     cout << " Execution continuing...\n" << flush;
#endif
               }

	       help_defined = TRUE;
	       msghelp_defined = TRUE;
	       sprintf(msghelpfile,"%s",helpfile);

#ifndef MUR_NODB
	       savedXflag = wrmess.body->Xclientactflag;
	       wrmess.body->Xclientactflag = 1;
	       if (databases)
	       {
	          hdesc =  open(helpfile,O_RDONLY);
	          if (hdesc  == -1)
	          {
	  	     perror(helpfile);
		     exit(-1);
	          }
	          helpfilenumber++;
	          if (MUR_MSG_FAIL(helpfilelist.find(helpfile)))
		      helpfilelist.append(helpfile,helpfilenumber,0);
		  
/*
**	reset help list object and help text in preparation for the new
*/
	          clrstr(helptext);
	          msghelplist.clear();

	          nbytes = read (hdesc, helptext, sizeof(helptext)-1);
	          helptext[nbytes] = 0;
	          if (dumpobj)
	          {
	             cout << "*** help text: " << helptext << "\n" << flush;
	             cout << "*** bytes read: " << nbytes << "\n" << flush;
	          }
	          msghelplist.append("Product Help",MUR_MOUSE_ACTION_TITLE,
				  MUR_MOUSE_ACTION_INTERNAL,1);
	          msghelplist.append(helptext,MUR_MOUSE_ACTION_HELP_TEXT,
				  MUR_MOUSE_ACTION_INTERNAL,1);

	          if (dumpobj) cout << msghelplist << "\n";
		  clrstr(helpfile);
	          close(hdesc);
	       }
#endif

	    }
	    else if (strncmp(currentkeyword->name,"-NOHELP",strlen(currentkeyword->name)) == 0)
	    {
	       msghelp_defined = FALSE;
#ifndef MUR_NODB
	       wrmess.body->Xclientactflag = 0;
#endif
	    }
	    else
	    {
	       yyerror("Invalid Keyword");
	    }/* end keyword comparison */
	 }/* end for loop */

	 clrstr(keystring);
	 resetlist(firstkeyword);
	 currentkeyword = firstkeyword;

      }/* end if keyedID */

      if (token == BLANKLINE )
      {
      }
      else if (token == ENDMARKER)
      {
      }
      else if ((token == ID) || (token == KeyedID))	/*** temporary thing ***/
      {

#ifndef MUR_NODB

/*
**	Make sure message doesn't already exist (case sensitivity check)
*/
	sprintf(newmessage,"%s",wrmess.body->mnemonic);
        if (nocasecheck) goto skip_casecheck;
	if (!casecheck(newmessage))
	{
	    cerr << "Message omitted\n" << flush;
	    error_count++;
	    goto next_token;
	}

skip_casecheck:

	if (wrmess.body->Xclientactflag != 1) goto skip_helpfile;
	if (msghelp_defined )
	{
	   if (MUR_MSG_SUCCESS(helpfilelist.find(msghelpfile)))
	   {
	      helpfilelist.setitem2(helpfilelist.item2()+1);
	      if (!nocasecheck) mnemoniclist.append(newmessage,helpfilelist.item1());
	   }
	}
	else 
	{
	   if (MUR_MSG_SUCCESS(helpfilelist.find(defhelpfile)))
           {
	      helpfilelist.setitem2(helpfilelist.item2()+1);
              if (!nocasecheck) mnemoniclist.append(newmessage,helpfilelist.item1());
	   }
	}
#endif
		
skip_helpfile:

/*
**	write header files
*/
	 if (noprefix)
	 {
            fprintf(cdesc,"#define	   %s    0X%X",
		 message_mnemonic,	
		 message_code);
            fprintf(cxxdesc,"const	unsigned long    %s = 0X%X;",
		 message_mnemonic,	
		 message_code);
	 }
	 else
	 {
            fprintf(cdesc,"#define	   %s_%s    0X%X",
		 prefix_name,message_mnemonic,	
		 message_code);
            fprintf(cxxdesc,"const	unsigned long    %s_%s = 0X%X;",
		 prefix_name,message_mnemonic,	
		 message_code);
	 }

	 if (trailingcomment) 
	 {
/* strip carraige  return  from   comment  */
	    commentstring[strlen(commentstring)-1] = 0;
	    fprintf(cdesc," /* %s */\n",&commentstring[1]);
	    fprintf(cxxdesc," // %s\n",&commentstring[1]);
	    fprintf(Fdesc,"C\nC %s\nC\n",&commentstring[1]);
	 }
	 else
	 {
	    fprintf(cdesc,"\n");
	    fprintf(cxxdesc,"\n");
	 }
	 if (noprefix)
	 {
            fprintf(Fdesc,"\tINTEGER     %s\n",message_mnemonic);
            fprintf(Fdesc,"\tPARAMETER (%s = %d)\n\n",
		 message_mnemonic,	
		 message_code);
	 }
	 else
	 {
            fprintf(Fdesc,"\tINTEGER     %s_%s\n",prefix_name,
					     message_mnemonic);
            fprintf(Fdesc,"\tPARAMETER (%s_%s = %d)\n\n",
		 prefix_name,message_mnemonic,	
		 message_code);
	 }
	 msg_count++;
	 msg_defined = TRUE;

#ifndef MUR_NODB
         if(databases)
	 {
	    clrstr(key);
	    sprintf(key,"%8.8X",MUR_MSG_STRIP_SEV(wrmess.body->code));
	    status = dbInterface->write(key,wrmess);
	    if (MUR_MSG_FAIL(status))
	    {
		cout  << "dbInterface write failed \n" << flush;
		exit(0);
	    }
	    dbcount++;
	    if (dumpobj) cout << wrmess << "\n";

	    clrstr(key);
	    if (wrmess.body->groupflag) 
	    {
	       sprintf(key,"%8.8XGroupList",MUR_MSG_STRIP_SEV(wrmess.body->code));
	       if (msggroups_defined)
	          status = GInterface->write(key,msggrouplist);
	       else
	          status = GInterface->write(key,defgrouplist);
	       
	       if (MUR_MSG_FAIL(status))
	       {
	          cout << "GInterface write failure" << status << "\n" << flush;
		  exit(0);
	       }

	       Gcount++;

	       status = GInterface->fetch("GroupList",murgrouplist);
	       if (MUR_MSG_SUCCESS(status))
	       {
		  if (msggroups_defined)
		  {
	             updateGroupCount(murgrouplist,msggrouplist);
		     wrmess.body->groupflag = savedGflag;
		     msggroups_defined = FALSE;		     
		  }
	          else 
		     updateGroupCount(murgrouplist,defgrouplist);

		  status = GInterface->write("GroupList",murgrouplist);
	       }
	       else
	       {
	          cout << "GInterface Fetch failure" << status << "\n" << flush;
		  exit(0);
	       }
	    }
	    else
	       wrmess.body->groupflag = savedGflag;	/* restore to saved state */

	    if (wrmess.body->Xclientactflag) 
	    {
	       clrstr(key);
               sprintf(key,"%8.8XMouseMenu",MUR_MSG_STRIP_SEV(wrmess.body->code));
	       if (dumpobj)cout << "key= " << key << "...\n" << flush;

	       if (msghelp_defined)
	       {
	          status = XInterface->write(key,msghelplist);
		  wrmess.body->Xclientactflag = savedXflag;	/* restore to original state */
		  msghelp_defined = FALSE;
	          clrstr(msghelpfile);
		  msghelplist.clear();
	       }
	       else
	          status = XInterface->write(key,defhelplist);
	       if (MUR_MSG_FAIL(status))
	       {
	          cout << "Xinterface Write failure" << status 
		       << "\n"  <<  flush;
		  exit(0);
	       }
	       Xcount++;
	    }
	    else  
               wrmess.body->Xclientactflag = savedXflag;	/*restore to saved state */

         } /* end if  databases */
#endif

	 if (trailingcomment)
	 { 	
            trailingcomment = FALSE;
	    clrstr(commentstring); 
         }
	 clrstr(txtstring);
	 clrstr(idstring);
      }
      else if (token == COMMENT)
      {

/* strip newline from comment */
	 commentstring[strlen(commentstring)-1] = 0;
	 fprintf(cdesc,"/* %s */\n",&commentstring[1]);

	 fprintf(cxxdesc,"// %s\n",&commentstring[1]);
         fprintf(Fdesc,"C %s\n",&commentstring[1]);
	 clrstr(commentstring);
      }
      else if (token == KEYWORD)
      {
         for (currentkeyword = firstkeyword->next; currentkeyword;
	      currentkeyword = currentkeyword->next)
	 {
	    if (nofacility && 
	       (strncmp(currentkeyword->name,"-FACILITY",strlen(currentkeyword->name)) != 0) )
	    {
	      yyerror("FACILITY has not been defined!");
	       exit(0);
	    }
	    if (strncmp(currentkeyword->name,"-FACILITY",strlen(currentkeyword->name)) == 0)
	    {
               fprintf(cdesc,"#define %s_facnum 0X%X",
		       facility_name, facility_number);
               fprintf(cxxdesc,"const unsigned long %s_facnum = 0X%X;",
	 	       facility_name, facility_number);

               if (trailingcomment)
	       {
/*	strip newline from comment string  */
	          commentstring[strlen(commentstring)-1] = 0;
                  fprintf(cdesc," # %s\n",&commentstring[1]);
                  fprintf(cxxdesc," // %s\n",&commentstring[1]);
	          fprintf(Fdesc,"C\nC %s\nC\n",&commentstring[1]);
               }
	       else 
               {
                  fprintf(cdesc,"\n");
                  fprintf(cxxdesc,"\n");
	       }	 
               fprintf(Fdesc,"\tINTEGER %s_facnum\n",facility_name);
               fprintf(Fdesc,"\tPARAMETER (%s_facnum = %d)\n\n",
		       facility_name, facility_number);

	       nofacility = FALSE;

#ifndef MUR_NODB
	       if (databases)
	       {
	          faclist.append(facility_name,facility_number);
	          status = GInterface->write("FacilityList",faclist);		
	          if (MUR_MSG_FAIL(status))
	          {
	             cout << "GInterface Write failure" << status << "\n" << flush;
	   	     exit(0);
	          }
	          Gcount++;
	          if (dumpobj) cout << faclist << "\n";

	       }
#endif
	       if (trailingcomment)
	       {
	          trailingcomment = FALSE;
	          clrstr(commentstring);
	       }
	    }
	    else if(strncmp(currentkeyword->name,"-GROUPS",strlen(currentkeyword->name)) == 0)
	    {
	       groups_defined = TRUE;
		
#ifndef MUR_NODB
	       defgrouplist.clear();
	       for (currentgroup = firstgroup->next; currentgroup;
		    currentgroup = currentgroup->next)
		    defgrouplist.append(currentgroup->name,1);
	
	       resetlist(firstgroup);
	       currentgroup = firstgroup;

	       wrmess.body->groupflag = 1;
	       savedGflag = 1;

  	       if (databases)
	       {
	          status = GInterface->fetch("GroupList",murgrouplist);
	          if (MUR_MSG_FAIL(status))
	          {
	             cout << "GInterface write failure"<< status 
	   	          << "\n" << flush;
                     exit(0);
	          }

	          updateGroupList(murgrouplist,defgrouplist);
	          if (dumpobj) cout << murgrouplist << "\n" << flush;

	          status = GInterface->write("GroupList",murgrouplist);
	          if (MUR_MSG_FAIL(status))
	          {
	             cout << "GInterface write failure"<< status 
		          << "\n" << flush;
                     exit(0);
	          }
	       }
#endif
	    }
	    else if(strncmp(currentkeyword->name,"-NOGROUPS",strlen(currentkeyword->name)) == 0)
	    {
#ifndef MUR_NODB
	       defgroups_defined = FALSE;
	       wrmess.body->groupflag = 0;
	       savedGflag = 0;
#endif
	    }
	    else if(strncmp(currentkeyword->name,"-NOHELP",strlen(currentkeyword->name)) == 0)
	    {
	       defhelp_defined = FALSE;
#ifndef MUR_NODB
	       wrmess.body->Xclientactflag = 0;
	       savedXflag = 0;
#endif
	    }
	    else if(strncmp(currentkeyword->name,"-NOPREFIX",strlen(currentkeyword->name)) == 0)
	    {
	       noprefix = TRUE;
	    }
	    else if(strncmp(currentkeyword->name,"-BASE",strlen(currentkeyword->name)) == 0)
	    {
	    }
	    else if(strncmp(currentkeyword->name,"-HELP",strlen(currentkeyword->name)) == 0)
	    {
	       if (helpfile[0] == '$') status = mur_Translate(helpfile);
	       if (!status)
	       {
#ifdef MUR_NODB
		  printf("Can't Translate environmental variable: %s\n",
			  helpfile);
	 	  printf("Execution contining...\n");
#else
	          cerr << "Error Translating Environmental Variable: "<< helpfile 
		       << "\n" << flush;
		  if (databases)
		     {
		     cerr << "Terminating Program\n" << flush;
	    	     exit(0);
		     }
		  else
		     cout << " Execution continuing...\n" << flush;
#endif
               }

	       sprintf(defhelpfile,"%s",helpfile);

	       help_defined = TRUE;
	       defhelp_defined = TRUE;
	       savedXflag = 1;

#ifndef MUR_NODB
	       wrmess.body->Xclientactflag = 1;
	       if (databases)
	       {
	          hdesc =  open(helpfile,O_RDONLY);
	          if (hdesc  == -1)
	          {
	  	     perror(helpfile);
		     exit(-1);
	          }
	          helpfilenumber++;
	          if (MUR_MSG_FAIL(helpfilelist.find(helpfile)))
		      helpfilelist.append(helpfile,helpfilenumber,0);
		  
/*
**	reset help list object and help text in preparation for the new
*/
	          clrstr(helptext);
	          defhelplist.clear();

	          nbytes = read (hdesc, helptext, sizeof(helptext)-1);
	          helptext[nbytes] = 0;
	          if (dumpobj)
	          {
	             cout << "*** help text: " << helptext << "\n" << flush;
	             cout << "*** bytes read: " << nbytes << "\n" << flush;
	          }
	          defhelplist.append("Product Help",MUR_MOUSE_ACTION_TITLE,
				  MUR_MOUSE_ACTION_INTERNAL,1);
	          defhelplist.append(helptext,MUR_MOUSE_ACTION_HELP_TEXT,
				  MUR_MOUSE_ACTION_INTERNAL,1);

	          if (dumpobj) cout << defhelplist << "\n";
	          defhelp = TRUE;
		  clrstr(helpfile);
	          close(hdesc);
	       }
#endif
	    }
	    else if(strncmp(currentkeyword->name,"-SEVERITY",strlen(currentkeyword->name)) == 0)
	    {
	       sprintf(defcolor,"%s",color);
	       sprintf(defsevstring,"%s",sevstring);
	       defseverity_number = severity_number;
	      
	    }/* specific keywords IF */

            if (trailingcomment)
	    {
	       trailingcomment = FALSE;
	       clrstr(commentstring);
	    }
	    clrstr(keystring);
         }/* End for loop  */

	 resetlist(firstkeyword);
	 currentkeyword = firstkeyword;

      }/* token = KEYWORD if */

      if (listing)
      {
         line_number++;
	 if (msg_defined)
	 {
#ifndef MUR_NODB
	    fprintf(listdesc,"%8.8X %5d %s",wrmess.body->code,
		    line_number,inputline);
#else
	    fprintf(listdesc,"%8.8X %5d %s",message_code,
		    line_number,inputline);
#endif
	    msg_defined = FALSE;
	 }
	 else
            fprintf(listdesc,"%14d %s",line_number,inputline);

	 if (inputline[strlen(inputline)-1]  != '\n')
	    fprintf(listdesc,"\n");


	 if  (error_flag)
         {
	    fprintf(listdesc,"\n***line %d - %s\n\n",line_number,error_text);
	    error_flag =  FALSE;
	    clrstr(error_text);
         }	 

      }/* listing output */
   }  /* end while loop */


#ifndef MUR_NODB
  if (databases)
  {
/* 
** write out default routing record and default  display 
** configuration record
*/
      status = dbInterface->write("DefaultRoute",defaultroute);
      if (MUR_MSG_FAIL(status))
      {
         cout << "dbInterface Write Failure on DefaultRoute record\n" << flush;
         exit(0);
      }
      dbcount++;

      status = XInterface->write("DisplayConfig",displayconfig);
      if (MUR_MSG_FAIL(status))
      {
         cout << "XInterface Write Failure on DisplayConfig record\n" << flush;
         exit(0);
      }
      Xcount++;
   }

#endif

/*
** terminate product_MSG_Cxx_HEADER  ifdef
*/
   fprintf(cdesc,"#endif\n");
   fprintf(cxxdesc,"#endif\n"); 
/*
** Write  out  listing file  accounting information
*/

  if (listing)
  {
     fprintf(listdesc,"\n***************\n\n");
     fprintf(listdesc,"Total Number of Messages : %d\n",msg_count);
     fprintf(listdesc,"Total Error Count : %d\n\n",error_count);

#ifndef MUR_NODB
     if (databases)
     {
        fprintf(listdesc,"Created Database:  %s, loaded %d  records\n",
	         dbfile, dbcount);
        fprintf(listdesc,"Created Database:  %s, loaded %d  records\n",
	         guieditdbfile, Gcount);
        fprintf(listdesc,"Created Database:  %s, loaded %d  records\n",
	         xclientdbfile, Xcount);
        fprintf(listdesc,"Created Database:  %s, loaded %d  records\n",
	         messactdbfile,0);
        
	if (groups_defined) printGroups(listdesc, dbInterface, GInterface);
	if (help_defined) printHelps(listdesc);
     }
     else
	fprintf(listdesc,"No Databases Created by Request\n");
#endif

  } /* end listing */

/* Quit normally. */

  fclose(cdesc);
  fclose(cxxdesc);
  fclose(Fdesc);
  if (listing) fclose(listdesc);

  exit (0);
}


