%{
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <strings.h>
#include  "message.h"

#ifndef MUR_NODB
extern mur_WrMessage wrmess;
#endif

extern	char facility_name[];
extern	int facility_number;

#ifndef MUR_NODB
extern "C"
{
void addtolist(struct element *, char *);
void resetlist(struct element *);
void clrstr(char *);
void yyerror( char *);
void clrlist(mur_WrGroupList);
int  yylex();
int yyparse();
}
#else
extern int yylex();
extern int yyparse();
void clrstr();
void addtolist();
void resetlist();
#endif

#ifndef MUR_NODB
void	
fill_argtypes(char s[]) {

char *ptr;
int  i=0;

for (ptr=strchr(s,'%'); ptr; ptr=strchr(ptr,'%'))
{
   ptr++;	/* increment to next character after '%' */
   if (isspace(ptr[0])) 
   {
      yyerror("Invalid conversion specifier");
      return;
   }
   else if (ptr[0] == '%')
      ptr++;	/* '%%' found so continue looking for specifiers */   
   else 
   {
      while (!isalpha(ptr[0]))ptr++; /* skip field widths, etc */
      switch(ptr[0]) {
         case 'd' : wrmess.body->argtypes[i] = MUR_LONG;
		    break;
	 
	 case 'f' : wrmess.body->argtypes[i] = MUR_FLOAT;
	            break;

	 case 's' : wrmess.body->argtypes[i] = MUR_STRING;
		    break;

	 case 'u' :
	 case 'x' :
	 case 'X' : 
	 case 'o' : 
	            wrmess.body->argtypes[i] = MUR_U_LONG;
	            break;

	 default  : yyerror("Invalid conversion specifier");
	            return;
	 	 }

      i++;
   }
} /* end for loop */

for (i;i<=9;i++)	/* clear remaining argtypes fields */
   wrmess.body->argtypes[i] = 0;
}

#endif

char	*list_items[10];
char	severity[2];
char	filename[256];
char	tmp_txtstring[256];

extern	struct	element *currentkeyword;
extern	struct	element *currentgroup;
extern 	struct	element *keywords;
extern 	struct	element *groups;

extern	char	prefix_name[];
extern	char	message_mnemonic[];
extern	char keystring[];
extern	char txtstring[];
extern	char commentstring[];
extern	char sevstring[];
extern  char defsevstring[];
extern	char color[];
extern  char defcolor[];
extern  char trailingcomment;
extern  char noprefix;
extern  int  base;
extern  char yytext[];
extern  char inputline[];
extern  message_code;	/* encoded message code including facility, severity & msg number */
extern int	message_number;	/* message number generated from the base */
extern int	severity_number;
extern int	defseverity_number;

int 	nofacility = TRUE;
int	number_items = 0;
int 	i = 0;
int	sev;
%}

%start line
%union {
	int int_val;	
	char *char_ptr;
	}

%token <char_ptr> COMMENT
%token <char_ptr> ID
%token <char_ptr> TEXT
%token <char_ptr> KEYWORD
%token <int_val>  HEXNUMB
%token <int_val>  OCTNUMB
%token <int_val>  DECNUMB
%token <char_ptr> GROUP
%token <char_ptr> SEVERITY
%token <char_ptr> HFILE
%token <int_val>  CONTINUATION
%token <int_val>  BLANKLINE
%token <int_val>  KeyedID
%token <int_val>  ENDMARKER	0

%type <int_val> key_expression
%type <int_val> msg_expression
%type <int_val> keyedmsg_expression
%type <int_val> parameters
%type <int_val> number
%type <int_val> groups
%%

line 	: /* empty line */ {return (BLANKLINE);}
	|	key_expression 	{return(KEYWORD);}
	|	msg_expression  
	|	comment 	
	;

key_expression 	:	KEYWORD
			{
			if (strncmp($<char_ptr>1,"-NOGROUPS",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
 			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>1,"-NOHELP",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>1,"-NOPREFIX",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else 
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			}
		|	KEYWORD	groups
			{
			if (strncmp($<char_ptr>1,"-GROUPS",strlen($<char_ptr>1)) != 0)
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			}
		|	KEYWORD	  parameters	
			{
			if (strncmp($<char_ptr>1,"-FACILITY",strlen($<char_ptr>1)) == 0)
		           {
		           /* do nothing */
			   }
			else if (strncmp($<char_ptr>1,"-BASE",strlen($<char_ptr>1)) == 0)
			   if (base >= message_number)
			      {
			      message_number = base;
			      }
			   else
			      yyerror("Invalid base - less than current message number");
			else if (strncmp($<char_ptr>1,"-SEVERITY",strlen($<char_ptr>1)) == 0)
			{
			   /* do nothing */
		 	}
			else if (strncmp($<char_ptr>1,"-PREFIX",strlen($<char_ptr>1)) == 0)
			{
			   noprefix = FALSE;
		 	}
			else if (strncmp($<char_ptr>1,"-NOPREFIX",strlen($<char_ptr>1)) == 0)
			{
		 	}
			else if (strncmp($<char_ptr>1,"-GROUPS",strlen($<char_ptr>1)) == 0)
			{
			}
			else if (strncmp($<char_ptr>1,"-NOGROUPS",strlen($<char_ptr>1)) == 0)
			{
		 	}
			else if (strncmp($<char_ptr>1,"-HELP",strlen($<char_ptr>1)) == 0)
			{
		 	}
			else if (strncmp($<char_ptr>1,"-NOHELP",strlen($<char_ptr>1)) == 0)
			{
		 	}
			else if (strncmp($<char_ptr>1,"-END",strlen($<char_ptr>1)) == 0)
			{
			}
			else
			{
			   yyerror("Invalid keyword");
			   return(MURMSG_INVPARAMETER);
			}
			}
		|	key_expression	KEYWORD	ID
			{
			if (strncmp($<char_ptr>2,"-PREFIX",strlen($<char_ptr>2)) != 0)
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}

			if (strlen($<char_ptr>3) > MUR_MAX_PREFIX_LENGTH)
			{
			   yyerror("Prefix too long");
			   return(MURMSG_STRING_TOOLONG);
		        }
			else
			   strcpy(prefix_name,$<char_ptr>3);

			}
		|	key_expression	KEYWORD	SEVERITY
			{
			if (strncmp($<char_ptr>2,"-SEVERITY",strlen($<char_ptr>2)) != 0)
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			switch(sevstring[0])
			   {
			   case 'S' :
			      severity_number = MUR_SEV_SUCCESS;
			      sprintf(color,"%s",MUR_COLOR_GREEN);
			      break;

			   case 'W' :
			      severity_number = MUR_SEV_WARNING;
			      sprintf(color,"%s",MUR_COLOR_YELLOW);
			      break;

		  	   case 'I' : 
			      severity_number = MUR_SEV_INFORM;
			      sprintf(color,"%s",MUR_COLOR_BLUE);
			      break;

			   case 'E' :
			      severity_number = MUR_SEV_ERROR;
			      sprintf(color,"%s",MUR_COLOR_RED);
			      break;

			   default  :
			      yyerror("Invalid severity ");
			      return(MURMSG_INVPARAMETER);
			   }
			}
		|	key_expression	KEYWORD groups
			{
			if (strncmp($<char_ptr>2,"-GROUPS",strlen($<char_ptr>2)) != 0)
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			}
		|	key_expression	KEYWORD	number 
			{
			if (strncmp($<char_ptr>2,"-BASE",strlen($<char_ptr>2)) != 0)
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			else 
		        {
			   base = $3;
			   if (base >= message_number)
			      {
			      message_number = base;
			      }
			   else
			      yyerror("Invalid base - less than current message number");

	                }
			}
		|	key_expression  KEYWORD	HFILE
			{
			if (strncmp($<char_ptr>2,"-HELP",
					    strlen($<char_ptr>2))==0)
			   strcpy(filename,$<char_ptr>3);			   
			else
			   yyerror("Invalid use of filename argument");
			}
		|	key_expression	KEYWORD
			{
			if (strncmp($<char_ptr>2,"-NOGROUPS",strlen($<char_ptr>2)) == 0)
			{
			   if   (strlen($<char_ptr>2) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>2,"-NOHELP",strlen($<char_ptr>2)) == 0)
			{
			   if   (strlen($<char_ptr>2) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>2,"-NOPREFIX",strlen($<char_ptr>2)) == 0)
			{
			   if   (strlen($<char_ptr>2) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else 
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			}
		|	key_expression 	COMMENT 
			{
			 trailingcomment = TRUE;
			}
		;

msg_expression	:	ID	TEXT  
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			if (strlen($<char_ptr>2) > MUR_MAX_MSGTEXT_LENGTH)
			{
			   yyerror("Text too long (max 132)");
			   return(MURMSG_STRING_TOOLONG);
			}
			strncpy(tmp_txtstring,&txtstring[1],
				strlen(txtstring)-2);
#ifndef MUR_NODB
			fill_argtypes(tmp_txtstring);
#endif
			if (defseverity_number == 0)
		        {
			   yyerror("Undefined SEVERITY");
			   return(MURMSG_INVPARAMETER);
		        }
			message_code = (1<<MUR_MSB) 
			 	     | (facility_number<<MUR_LSB_FAC) 
				     | (message_number<<MUR_LSB_MSG)
				     |  defseverity_number;
		 	message_number++;
			sprintf(message_mnemonic,"%s",$1);
#ifndef MUR_NODB
			wrmess.body->code = message_code;
			sprintf(wrmess.body->hexcode,"%8.8X",message_code);
			sprintf(wrmess.body->text,"%s",tmp_txtstring);
			sprintf(wrmess.body->mnemonic,"%s",$1);

			if (noprefix)
			   sprintf(wrmess.body->prefix,"%s","");
			else
			   sprintf(wrmess.body->prefix,"%s",prefix_name);

			sprintf(wrmess.body->facility,"%s",facility_name);
			sprintf(wrmess.body->severity,"%s",defsevstring);
			if (noprefix)
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
				   wrmess.body->facility,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);
			else
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
			  	   wrmess.body->prefix,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);

			sprintf(wrmess.body->color,"%s",defcolor);
#endif
			clrstr(tmp_txtstring);
			return(ID);
			}

		|	ID	TEXT	 COMMENT  
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			if (strlen($<char_ptr>2) > MUR_MAX_MSGTEXT_LENGTH)
			{
			   yyerror("Text too long (max 132)");
			   return(MURMSG_STRING_TOOLONG);
			}
			strncpy(tmp_txtstring,&txtstring[1],
				strlen(txtstring)-2);
#ifndef MUR_NODB

#endif			fill_argtypes(tmp_txtstring);

			if (defseverity_number == 0)
		        {
			   yyerror("Undefined SEVERITY");
			   return(MURMSG_INVPARAMETER);
		        }

			message_code = (1<<MUR_MSB) 
			 	     | (facility_number<<MUR_LSB_FAC) 
				     | (message_number<<MUR_LSB_MSG)
				     |  defseverity_number;
		 	message_number++;
			sprintf(message_mnemonic,"%s",$1);
#ifndef MUR_NODB
			wrmess.body->code = message_code;
			sprintf(wrmess.body->hexcode,"%8.8X",message_code);
			sprintf(wrmess.body->text,"%s",tmp_txtstring);
			sprintf(wrmess.body->mnemonic,"%s",$1);

			if (noprefix)
			   sprintf(wrmess.body->prefix,"%s","");
			else
			   sprintf(wrmess.body->prefix,"%s",prefix_name);

			sprintf(wrmess.body->facility,"%s",facility_name);
			sprintf(wrmess.body->severity,"%s",defsevstring);

			if (noprefix)
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
				   wrmess.body->facility,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);
			else
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
			  	   wrmess.body->prefix,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);

			sprintf(wrmess.body->color,"%s",defcolor);
#endif
			trailingcomment = TRUE;
			clrstr(tmp_txtstring);
			return(ID);
 			}
		|	keyedmsg_expression	TEXT
			{
			if (strlen($<char_ptr>2) > MUR_MAX_MSGTEXT_LENGTH)
			{
			   yyerror("Text too long (max 132)");
			   return(MURMSG_STRING_TOOLONG);
			}
			strncpy(tmp_txtstring,&txtstring[1],
				strlen(txtstring)-2);
#ifndef MUR_NODB
			fill_argtypes(tmp_txtstring);
#endif
			if (severity_number == 0)
		        {
			   yyerror("Undefined SEVERITY");
			   return(MURMSG_INVPARAMETER);
		        }
			message_code = (1<<MUR_MSB) 
			 	     | (facility_number<<MUR_LSB_FAC) 
				     | (message_number<<MUR_LSB_MSG)
				     |  severity_number;
		 	message_number++;

#ifndef MUR_NODB
			wrmess.body->code = message_code;
			sprintf(wrmess.body->hexcode,"%8.8X",message_code);
			sprintf(wrmess.body->text,"%s",tmp_txtstring);
			sprintf(wrmess.body->mnemonic,"%s",message_mnemonic);

			if (noprefix)
			   sprintf(wrmess.body->prefix,"%s","");
			else
			   sprintf(wrmess.body->prefix,"%s",prefix_name);

			sprintf(wrmess.body->facility,"%s",facility_name);
			sprintf(wrmess.body->severity,"%s",sevstring);

			if (noprefix)
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
				   wrmess.body->facility,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);
			else
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
			  	   wrmess.body->prefix,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);

			sprintf(wrmess.body->color,"%s",color);
#endif
			clrstr(tmp_txtstring);
			return(KeyedID);
			}
		|	keyedmsg_expression	TEXT	COMMENT
			{
			if (strlen($<char_ptr>2) > MUR_MAX_MSGTEXT_LENGTH)
			{
			   yyerror("Text too long (max 132)");
			   return(MURMSG_STRING_TOOLONG);
			}
			strncpy(tmp_txtstring,&txtstring[1],
				strlen(txtstring)-2);
#ifndef MUR_NODB
			fill_argtypes(tmp_txtstring);
#endif
			if (severity_number == 0)
		        {
			   yyerror("Undefined SEVERITY");
			   return(MURMSG_INVPARAMETER);
		        }
			message_code = (1<<MUR_MSB) 
			 	     | (facility_number<<MUR_LSB_FAC) 
				     | (message_number<<MUR_LSB_MSG)
				     |  severity_number;
		 	message_number++;
#ifndef MUR_NODB
			wrmess.body->code = message_code;
			sprintf(wrmess.body->hexcode,"%8.8X",message_code);
			sprintf(wrmess.body->text,"%s",tmp_txtstring);
			sprintf(wrmess.body->mnemonic,"%s",message_mnemonic);

			if (noprefix)
			   sprintf(wrmess.body->prefix,"%s","");
			else
			   sprintf(wrmess.body->prefix,"%s",prefix_name);

			sprintf(wrmess.body->facility,"%s",facility_name);
			sprintf(wrmess.body->severity,"%s",sevstring);

			if (noprefix)
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
				   wrmess.body->facility,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);
			else
			   sprintf(wrmess.body->precomputed,"%s_%s_%s",
			  	   wrmess.body->prefix,
			           wrmess.body->severity,
				   wrmess.body->mnemonic);

			sprintf(wrmess.body->color,"%s",color);
#endif
		 	trailingcomment = TRUE;
			clrstr(tmp_txtstring);
			return(KeyedID);
			}
		; 

keyedmsg_expression : 	ID	KEYWORD
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			if (strncmp($<char_ptr>1,"-NOGROUPS",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
 			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>1,"-NOHELP",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>1,"-NOPREFIX",strlen($<char_ptr>1)) == 0)
			{
			   if   (strlen($<char_ptr>1) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			}
		    |	ID	KEYWORD	 SEVERITY
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			switch(sevstring[0])
			   {
			   case 'S' :
			      severity_number = MUR_SEV_SUCCESS;
			      sprintf(color,"%s",MUR_COLOR_GREEN);
			      break;

			   case 'W' :
			      severity_number = MUR_SEV_WARNING;
			      sprintf(color,"%s",MUR_COLOR_YELLOW);
			      break;

		  	   case 'I' : 
			      severity_number = MUR_SEV_INFORM;
			      sprintf(color,"%s",MUR_COLOR_BLUE);
			      break;

			   case 'E' :
			      severity_number = MUR_SEV_ERROR;
			      sprintf(color,"%s",MUR_COLOR_RED);
			      break;

			   default  :
			      yyerror("Invalid severity ");
			      return(MURMSG_INVPARAMETER);
			   }
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			}
		    |	ID	KEYWORD	groups
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			}
		    |	ID	KEYWORD	  HFILE
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}

			sprintf(message_mnemonic,"%s",$<char_ptr>1);

			if (strncmp($<char_ptr>2,"-HELP",
					    strlen($<char_ptr>2))==0)
			   strcpy(filename,$<char_ptr>3);			   
			else
			   yyerror("Invalid use of filename argument");
			}
	            |	ID	key_expression KEYWORD
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			if (strncmp($<char_ptr>3,"-NOGROUPS",strlen($<char_ptr>3)) == 0)
			{
			   if   (strlen($<char_ptr>3) < 4)
 			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>3,"-NOHELP",strlen($<char_ptr>3)) == 0)
			{
			   if   (strlen($<char_ptr>3) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else if (strncmp($<char_ptr>3,"-NOPREFIX",strlen($<char_ptr>3)) == 0)
			{
			   if   (strlen($<char_ptr>3) < 4)
			   {
			      yyerror("Ambiguous Keyword Specified");
			      return(MURMSG_INVPARAMETER);
	                   }		        
			}
			else 
			{
			    yyerror("Invalid Keyword");
			    return(MURMSG_INVPARAMETER);
			}
			}
		    |	ID	key_expression KEYWORD SEVERITY
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			
			if (strncmp($<char_ptr>3,"-SEVERITY",
					    strlen($<char_ptr>3))!=0)
			{
			  yyerror("Invalid Keyword");
			  return(MURMSG_INVPARAMETER);
			}

			switch(sevstring[0])
			   {
			   case 'S' :
			      severity_number = MUR_SEV_SUCCESS;
			      sprintf(color,"%s",MUR_COLOR_GREEN);
			      break;

			   case 'W' :
			      severity_number = MUR_SEV_WARNING;
			      sprintf(color,"%s",MUR_COLOR_YELLOW);
			      break;

		  	   case 'I' : 
			      severity_number = MUR_SEV_INFORM;
			      sprintf(color,"%s",MUR_COLOR_BLUE);
			      break;

			   case 'E' :
			      severity_number = MUR_SEV_ERROR;
			      sprintf(color,"%s",MUR_COLOR_RED);
			      break;

			   default  :
			      yyerror("Invalid severity ");
			      return(MURMSG_INVPARAMETER);
			   }
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			}
		    |	ID	key_expression KEYWORD HFILE
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			sprintf(message_mnemonic,"%s",$<char_ptr>1);

			if (strncmp($<char_ptr>3,"-HELP",
					    strlen($<char_ptr>3))==0)
			   strcpy(filename,$<char_ptr>4);			   
			else
			   yyerror("File name arg invalid");
			}
		    |	ID	key_expression KEYWORD	groups
			{
			if (strlen($<char_ptr>1) > MUR_MAX_MNEMONIC_LENGTH)
			{
			  yyerror("Mnemonic too long (max 16)");
			  return(MURMSG_STRING_TOOLONG);
			}
			sprintf(message_mnemonic,"%s",$<char_ptr>1);
			if (strncmp($<char_ptr>3,"-GROUPS",
					    strlen($<char_ptr>3))!=0)
			{
			   yyerror("Invalid Keyword");
			   return(MURMSG_INVPARAMETER);
			}
			}
		    ;

comment 	: 	COMMENT
			{
			return (COMMENT);
			}
		;

parameters 	:	ID
			{
			if (strncmp($<char_ptr>0,"-PREFIX",
			                    strlen($<char_ptr>0))==0)
			   if (strlen($<char_ptr>1) > MUR_MAX_PREFIX_LENGTH)
			   {
			      yyerror("Prefix too long");
			      return(MURMSG_STRING_TOOLONG);
		           }
			   else
			   {
			      strcpy(prefix_name,$1);
			      noprefix = TRUE;
			   }
			else
			   yyerror("Invalid ID or KEYWORD");
			}

		|	ID    number 
			{
			if (strncmp($<char_ptr>0,"-FACILITY",
					    strlen($<char_ptr>0))==0)
		        {
			   if (strlen($<char_ptr>1) > MUR_MAX_FACILITY_LENGTH)
			   {
			      yyerror("Facility name too long (max 16)");
			      return(MURMSG_STRING_TOOLONG);
			   }
			   if ($2 > MUR_MAX_FACILITY_NUMBER)
			   {
			      yyerror("Facility number exceeds 16383");
			      return(MURMSG_VAR_EXCEEDS_MAX);
			   }

			   strncpy(facility_name,$1,strlen($<char_ptr>1));
			   strncpy(prefix_name,$1,strlen($<char_ptr>1));
			   facility_number = $2;
			}
			else
			   yyerror("Invalid KEYWORD");
			}

		|	HFILE
			{
			if (strncmp($<char_ptr>0,"-HELP",
					    strlen($<char_ptr>0))==0)
			   strcpy(filename,$1);			   
			else
			   yyerror("File name arg invalid");
			}
		|	SEVERITY 
			{
			switch(sevstring[0])
			   {
			   case 'S' :
			      severity_number = MUR_SEV_SUCCESS;
			      sprintf(color,"%s",MUR_COLOR_GREEN);
			      break;

			   case 'W' :
			      severity_number = MUR_SEV_WARNING;
			      sprintf(color,"%s",MUR_COLOR_YELLOW);
			      break;

		  	   case 'I' : 
			      severity_number = MUR_SEV_INFORM;
			      sprintf(color,"%s",MUR_COLOR_BLUE);
			      break;

			   case 'E' :
			      severity_number = MUR_SEV_ERROR;
			      sprintf(color,"%s",MUR_COLOR_RED);
			      break;

			   default  :
			      yyerror("Invalid severity ");
			      return(MURMSG_INVPARAMETER);
			   }
			}
		|	number
			{
 			if (strncmp($<char_ptr>0,"-BASE",
					    strlen($<char_ptr>0))==0)
			   base = $1;
			else if (strncmp($<char_ptr>0,"-FACILITY",
					    strlen($<char_ptr>0))==0)
			   facility_number = $1;
			else
			   yyerror("Invalid keyword argument");
			}
		;

groups		:	GROUP
			{
			if (strncmp($<char_ptr>0,"-GROUPS",
					    strlen($<char_ptr>0))==0)
			{
			   addtolist(currentgroup,$<char_ptr>1);
			   currentgroup = currentgroup->next;
			}
			else
			   yyerror("Group inappropriate");
			}
		|	groups 	GROUP
			{
			if (strncmp($<char_ptr>0,"-GROUPS",
					    strlen($<char_ptr>0))==0)
			{
			   addtolist(currentgroup,$<char_ptr>2);
			   currentgroup = currentgroup->next;
			}
			else
			   yyerror("Invalid keyword");
			}
		;

number		:	DECNUMB
		|	HEXNUMB
		|	OCTNUMB
		;
