/**********************************************************************/
/*  This file is rd_mess_list.C                                       */
/*  It reads in the file of "interpreted" murmur messages (file       */
/*  location specified in logbook.h) and stores them for use by       */
/*  logbook in recording messages.                                    */
/**********************************************************************/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mur_mess_defs.h"
#include "logbook.h"

#ifdef _CPP
extern "C" int decode_filename(char *s,char *t);
#endif

#define MUR_MESS_LIST_LEN   100
struct mur_mes opr_mess_list[MUR_MESS_LIST_LEN];


#ifdef _CPP
void rd_mess_list()
#else
rd_mess_list()
#endif
/*  Read the list of err numbers and corresponding messages.  The list is  */
/*  stored globally.                                                       */

{
  FILE  *fp;
  struct mur_mes *p;
  u_long count=0;
  u_long mval;
  char rdstrng[256];
  char *status;

  if ( (decode_filename(MESSLIST,rdstrng) != 0) || 
       ((fp = fopen(rdstrng,"r")) == NULL) )  {
    printf ("\n message list file does not exist\n");
    opr_mess_list[count].mesnum = 0;
  }
  else   {

/*  Use a pointer to move through the elements of the structure.  The last */
/*  character read will be a <CR>, so overwrite that with a NULL.  Store   */
/*  hex error_code and the corresponding message in the structure sub-     */
/*  elements.                                                              */

    p = opr_mess_list;
    while ( (status = fgets(rdstrng,255,fp)) !=NULL) {
      rdstrng[strlen(rdstrng)-1] = '\0';
      sscanf (rdstrng, "0x%x", &mval);
      opr_mess_list[count].mesnum = mval;
      strcpy (p->mesmess, &rdstrng[11]);
      count++;
      p++;
    }
    opr_mess_list[count].mesnum = 0;

#ifdef DEBUG
    printf ("\n%d is the total number of messages read\n", count);
#endif

    fclose (fp);
  }
}
