/* ////////////////////////////////////////////////////////
//
// file:    runcon_win.C
// author:  C. Timmermans
// version: 2.0
// date:    3/10/93
/////////////////////////////////////////////////////// */

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "sdc_pack_msg_c.h"
#include "operator.h"
#include "runcon.h"

#include <X11/Xlib.h>

extern char runcontrol[];
extern int i_message;
extern XEvent report;

char str_privi[30];
int i_privi;
int rc_ysiz;


Window run_control;
GC rc_GC;
Window rc_bt[MAX_N_RC_BUT];
GC     rc_btGC[MAX_N_RC_BUT];

/* ////////////////////////////////////////////////////////////////
// Init_win_runco: initializes the window for communication with
// runco. 
/////////////////////////////////////////////////////////////// */
Init_win_runco()
{
  int i,but_x,but_y;

#ifdef _DEBUG
  printf("Starting to initialize the runco window\n");
#endif

  if(n_rc_but > MAX_N_RC_BUT) n_rc_but = MAX_N_RC_BUT;
  rc_ysiz = 50 + 40*((n_rc_but + 1)/2);
  gui_window(&run_control,&rc_GC,0,400,rc_ysiz,640,225,4,0,"Run Control");
  for(i = 0; i<n_rc_but;i++){
    but_x = 10+200*(i%2);
    but_y = 25 + 40*(i/2);
    gui_window(&(rc_bt[i]),&(rc_btGC[i]),&run_control,160,30,but_x,but_y,
	       1,2,"");
  }
  gui_display(&run_control);
  for(i = 0; i<n_rc_but;i++) gui_display(&(rc_bt[i]));
/* ///////////////////////////////////////////////////////////////
// Start having NO privilege
/////////////////////////////////////////////////////////// */
	i_privi = 0;
	strcpy(str_privi,"NOT privileged");
}

Execute_win_runco()
/* ////////////////////////////////////////////////////////
// After receiving a message execute screen is called
/////////////////////////////////////////////////////// */
{
  int i;

  if((report.type == ButtonRelease) || (report.type == ButtonPress)) {
/* if NOT privileged do not react to a button-press */
    if(i_privi == 0) {
      add_err_string("Any command");
      send_err_string(Oper_NO_Send);
      return;
    }
/* if operator has to react to a message, do not react to button-press */
    if(i_message > 0) return;
  }
  if(report.xkey.window == run_control)      update_run_control();
  else {
    for(i = 0;i<n_rc_but;i++){
      if(report.xkey.window == rc_bt[i]){
	update_rc_but(i);
	return;
      }
    }
  }
}


update_run_control()
{
  int y_txt;
  switch(report.type) {
  case Expose:
    y_txt = 40 + 40*((n_rc_but + 1)/2);
    gui_text(&run_control,&rc_GC,100,y_txt,str_privi);
    gui_text(&run_control,&rc_GC,10,15,"Runcontrol:");
    gui_text(&run_control,&rc_GC,82,15,runcontrol);
    break;
  }
}

update_rc_but(i_but)
int i_but;
{
  switch(report.type) {
  case Expose:
    gui_text(&(rc_bt[i_but]),&(rc_btGC[i_but]),5,20,rc_but[i_but].txt);
    break;
  case ButtonPress:
    gui_border(&(rc_bt[i_but]),2);
    break;
  case ButtonRelease:
    gui_border(&(rc_bt[i_but]),1);
    rc_but[i_but].action();
    break;
  }
}
