/*************************************************
 * new_status.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include "template.h"

int event_semid;  /* Delete later. */ 


/*(a+out) ------------------------------------------------- */
main(argc, argv)
int argc;
char * argv[];
/*(b+out)------------------------------------------------- 
Procedure Name
Main - main status-keeping procedure
Synopsis
Description
main(argc, argv) is the main status-keeping procedure. It
calls the template with the addresses of the Any_Event() and
Process_Event() procedures.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   int num,i;
   Table prt_table[20];
   char status[10];

   if (Attach_Table() == -1)
      printf("No such table\n");
   else {
      printf("\n");
      num = Get_Table(prt_table); 
      printf("process_name    pid    msgqid   status\n");
      printf("------------   -----   ------   ------\n");
      for (i=0;i<num;i++) {
         if (prt_table[i].status == ALIVE) strcpy(status, "ALIVE");
         else if (prt_table[i].status == DEAD) strcpy(status, "DEAD");
         printf(" %10s   %5d   %5d     %s\n", prt_table[i].process_name,
             prt_table[i].process_id, prt_table[i].msgq_id, status);
      }

   }

}

