/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/
/*********************************************************
 uni_config.h: determines setup of configuration tool
 Charles Timmermans, University of Michigan
 *********************************************************/
struct cnf_type {
  char txt[100];
  int (*action)();
};


/************************************************************
 The routines used to determine what happens when clicking buttons
 are to be listed here as:
 extern int routine();
 These routines are coded in file uni_action.c
 ************************************************************/
extern int config_nodefile();
extern int config_exit();
extern int config_start();
extern int config_command();
extern int config_operator();
extern int config_collector();
extern int config_dataview();

struct cnf_type cnf_but[] = {
/*********************************************
 For each button two fields are to be filled below:
 char txt[100]      The text to be displayed on the button
 int (*action)()    The routine to be called when clicking the button
 *********************************************/
  "Nodefile",     config_nodefile,
  "Start script", config_start,
  "Runcontrol",   config_command,
  "Operator",     config_operator,
  "Collector",    config_collector,
  "Dataview",     config_dataview,
  "Exit",         config_exit,
};

/*****************************************************
 The CNF_MAX variable needs to be at least as big as the 
 number of buttons defined.
 ******************************************************/

#define CNF_MAX 20

int cnf_nr = sizeof(cnf_but)/sizeof(struct cnf_type);



