c*************************************************
c hmapm.f,v
c*************************************************

*CMZ :  4.14/02 02/03/92  18.40.01  by  Rene Brun
*-- Author :    Fons Rademakers   20/03/91
*-- Modified:   Wojtek Burkot     01/03/92
      INTEGER FUNCTION HMAPM(MFILE, IBASE, IOFFST)

************************************************************************
*                                                                      *
* HMAPM                                                                *
*                                                                      *
* Create a global section. This routine causes the pages at ICOMAD     *
* to be mapped from file MFILE. MFILE must have been created in the    *
* /tmp directory. It returns in IOFFST the offset between ICOMAD and   *
* a base common IBASE (typically the PAWC). On successful completion   *
* this function returns 0. In case of an error -ERRNO is returned.     *
*                                                                      *
* HMAPM is an interface routine that calls the C routine HMAPI.        *
*                                                                      *
* After a global section has been created by HCREATEM, other           *
* processes can use the data in the global section via this function   *
* and HFREEM.                                                          *
*                                                                      *
************************************************************************
*
      CHARACTER*(*) MFILE
      INTEGER       ICOMAD(1), IBASE(1), HMAPI
*
************************************************************************
*                                                                      *
*  modification: set ICOMAD in input to required starting address of   *
*  mapping. Actual mapping address will be returned  in IOFFST.        *
*  This requires also a change in C routine HMAPI.                     *
*                                 02/03/1992    W.B.                   *
************************************************************************
      PARAMETER (MFEN=400000)
      CALL UCTOH(MFILE,MKEY,4,4)
      ICOMAD(1)=LOCF(ICOMAD)+MFEN
      HMAPM = HMAPI(MKEY, ICOMAD)
      IOFFST=ICOMAD(1)-LOCF(IBASE(1))
*
      END


