/*************************************
 This file is modified for dataview1
       (original: datawin.h)
           on 6 Dec.1994
           by M.Tairadate.
**************************************/
/**********************************************************
 FILE: datawin.h defines the variables to be displayed
 Author: C. Timmermans, University of Michigan
 **********************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

struct dw_def {
  char txt[20];
  int (*conversion)();
};

/********************************************************
  Please enter the action routines here. These routines descrbe
  the action taken when clicking a button. At this point
  they should be added as:
            extern int routine();
  These routines are to be coded in file dataconv.c, which 
  contains a description of how to do that
 ********************************************************/
extern int gen_num();

struct dw_def dview[] = {
/********************************************************
 For each variable to be displayed two fields needs to be filled:
 char txt[20];         The text to be displayed in front of the value
  int (*conversion)(); A routine converting the current data to a 
                       string. This routine needs to be added here as
                       (int(*)())routine
 *********************************************************/
  "Generated data",  (int (*)())gen_num,
}; 

/********************************************************
 The MAX_N_SL_DATA parameter needs to be at least as large 
 as the number of displayable variables defined above
 *******************************************************/
#define MAX_N_SL_DATA 10

int n_sl_data = sizeof(dview)/sizeof(struct dw_def);


